# Send comments to:
#   Dave Kuhlman
#   Reify
#   426 Madison Ave #9
#   Redwood City, CA 94061
#   415-368-8450
#   Internet: dkuhlman@netcom.com
#
# Copyright (c) 1994 G. David Kuhlman.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in
# all copies of this software.
#
# IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
# OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
# HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
# ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
# PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

#=============================================================
#
#   DBB.MAK
#
#=============================================================

# .AUTODEPEND

#=============================================================
#		Translator Definitions
#=============================================================
CC = bcc +DB.CFG
TASM = tasm.exe
TLIB = tlib.exe
TLINK = tlink
RC = brcc.exe
RB = rc.exe
LIBPATH = e:\BCOS2\LIB;e:\bcos2\classlib\lib
INCLUDEPATH = e:\BCOS2\INCLUDE;e:\bcos2\classlib\include;..\sup;..\h;d:\btree


#=============================================================
#		Implicit Rules
#=============================================================
.c.obj:
  $(CC) -c {$< }

.cpp.obj:
  $(CC) -c {$< }

#=============================================================
#		List Macros
#=============================================================


LIB_DEPENDENCIES =  \
 dbdir.obj \
 dbblk.obj \
 db.obj \
 bt.obj

#=============================================================
#		Explicit Rules
#=============================================================
db.lib: db.cfg $(LIB_DEPENDENCIES)
  - del db.lib
  $(TLIB) $<  @&&|
+dbdir.obj &
+dbblk.obj &
+db.obj &
+bt.obj
|
  - del ..\libb\db.lib
  move db.lib ..\libb


#=============================================================
#		Individual File Dependencies
#=============================================================
dbdir.obj: db.cfg dbdir.cpp ..\h\mdlsyn.hpp

dbblk.obj: db.cfg dbblk.cpp dbblk.hpp db.hpp ..\h\mdlsyn.hpp

db.obj: db.cfg db.cpp db.hpp

bt.obj: bt.cpp db.hpp ..\h\mdlsyn.hpp

#=============================================================
#		Compiler Configuration File
#=============================================================
db.cfg: dbb.mak
  copy &&|
-R
-K
-a4
-g10
-j15
-L$(LIBPATH)
-I$(INCLUDEPATH)
-vi-
-v
-w-par
| db.cfg


