// kr.h    Global definitions for kr parser.

/*
*
* Send comments to:
*   Dave Kuhlman
*   Reify
*   426 Madison Ave #9
*   Redwood City, CA 94061
*   415-368-8450
*   Internet: dkuhlman@netcom.com
*
* Copyright (c) 1994 G. David Kuhlman.
* All rights reserved.
*
* Permission is hereby granted, without written agreement and without
* license or royalty fees, to use, copy, modify, and distribute this
* software and its documentation for any purpose, provided that the
* above copyright notice and the following two paragraphs appear in
* all copies of this software.
* 
* IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
* DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
* OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
* HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
* ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
* PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*
*/

#ifndef kr_H
#define kr_H

#ifndef SCOPE
#define SCOPE extern
#endif // SCOPE

// Global variables:

SCOPE char * InFileName;
SCOPE char * OutFileName;
SCOPE FILE * InFile;
SCOPE FILE * OutFile;

enum {
    Tok_first_useless = 0,
    Tok_float_gram,    // 1
    Tok_int_gram,    // 2
    Tok_string_gram,    // 3
    Tok_documents_list_gram,    // 4
    Tok_authors_list_gram,    // 5
    Tok_keywords_list_gram,    // 6
    Tok_xrefs_list_gram,    // 7
    Tok_docnotes_list_gram,    // 8
    Tok_specialfields_list_gram,    // 9
    Tok_biases_list_gram,    // 10
    Tok_publishedworks_list_gram,    // 11
    Tok_worksinprogress_list_gram,    // 12
    Tok_authnotes_list_gram,    // 13
    Tok_emotionaltemperature_gram,    // 14
    Tok_doccount_gram,    // 15
    Tok_selecteditem_gram,    // 16
    Tok_bibltitle_gram,    // 17
    Tok_doctitle_gram,    // 18
    Tok_authorid_gram,    // 19
    Tok_docnotestitle_gram,    // 20
    Tok_style_gram,    // 21
    Tok_period_gram,    // 22
    Tok_topicarea_gram,    // 23
    Tok_name_gram,    // 24
    Tok_authnotestitle_gram,    // 25
    Tok_publisher_gram,    // 26
    Tok_location_gram,    // 27
    Tok_date_gram,    // 28
    Tok_pubs_id_gram,    // 29
    Tok_pubs_gram,    // 30
    Tok_nonfictionauthor_id_gram,    // 31
    Tok_nonfictionauthor_gram,    // 32
    Tok_romanticfictionauthor_id_gram,    // 33
    Tok_romanticfictionauthor_gram,    // 34
    Tok_humorfictionauthor_id_gram,    // 35
    Tok_humorfictionauthor_gram,    // 36
    Tok_fictionauthor_id_gram,    // 37
    Tok_fictionauthor_gram,    // 38
    Tok_author_id_gram,    // 39
    Tok_author_gram,    // 40
    Tok_document_id_gram,    // 41
    Tok_document_gram,    // 42
    Tok_bibliography_id_gram,    // 43
    Tok_bibliography_gram,    // 44
    Tok_file_top_gram,    // 45
    Tok_last_useless
};

#ifdef INIT
SCOPE char TokenNames[][64] = {
    "Tok_float_gram",    // 1
    "Tok_int_gram",    // 2
    "Tok_string_gram",    // 3
    "Tok_documents_list_gram",    // 4
    "Tok_authors_list_gram",    // 5
    "Tok_keywords_list_gram",    // 6
    "Tok_xrefs_list_gram",    // 7
    "Tok_docnotes_list_gram",    // 8
    "Tok_specialfields_list_gram",    // 9
    "Tok_biases_list_gram",    // 10
    "Tok_publishedworks_list_gram",    // 11
    "Tok_worksinprogress_list_gram",    // 12
    "Tok_authnotes_list_gram",    // 13
    "Tok_emotionaltemperature_gram",    // 14
    "Tok_doccount_gram",    // 15
    "Tok_selecteditem_gram",    // 16
    "Tok_bibltitle_gram",    // 17
    "Tok_doctitle_gram",    // 18
    "Tok_authorid_gram",    // 19
    "Tok_docnotestitle_gram",    // 20
    "Tok_style_gram",    // 21
    "Tok_period_gram",    // 22
    "Tok_topicarea_gram",    // 23
    "Tok_name_gram",    // 24
    "Tok_authnotestitle_gram",    // 25
    "Tok_publisher_gram",    // 26
    "Tok_location_gram",    // 27
    "Tok_date_gram",    // 28
    "Tok_pubs_id_gram",    // 29
    "Tok_pubs_gram",    // 30
    "Tok_nonfictionauthor_id_gram",    // 31
    "Tok_nonfictionauthor_gram",    // 32
    "Tok_romanticfictionauthor_id_gram",    // 33
    "Tok_romanticfictionauthor_gram",    // 34
    "Tok_humorfictionauthor_id_gram",    // 35
    "Tok_humorfictionauthor_gram",    // 36
    "Tok_fictionauthor_id_gram",    // 37
    "Tok_fictionauthor_gram",    // 38
    "Tok_author_id_gram",    // 39
    "Tok_author_gram",    // 40
    "Tok_document_id_gram",    // 41
    "Tok_document_gram",    // 42
    "Tok_bibliography_id_gram",    // 43
    "Tok_bibliography_gram",    // 44
    "Tok_file_top_gram",    // 45
    ""
};
#else // INIT
SCOPE char * TokenNames;
#endif // INIT


#endif // kr_H

