/*
 * A n t l r  T r a n s l a t i o n  H e a d e r
 *
 * Terence Parr, Will Cohen, and Hank Dietz: 1989-1994
 * Purdue University Electrical Engineering
 * With AHPCRC, University of Minnesota
 * ANTLR Version 1.23
 */
#include <stdio.h>
#define ANTLR_VERSION	123


#include "charptr.h"

#include "krg.h"
#define LL_K 2
#define GENAST

#include "ast.h"

#define zzEOF_TOKEN 1
#define zzSET_SIZE 12
#include "antlr.h"
#include "tokens.h"
#include "dlgdef.h"
#include "mode.h"
#include "ast.c"
zzASTgvars

ANTLR_INFO


// --------------------------------------------------------

#include "charptr.c"

#include "kr.h"

// --------------------------------------------------------

void create_ast(
AST *node,
Attrib *attr,
int token,
char *str
)
{
	int len;
	
    node->token = token;
	len = strlen(str);
	if (str[0] == '\"')
	{
		node->str = (char *)malloc(len - 1);
		strncpy(node->str, &str[1], len - 2);
		node->str[len - 2] = '\0';
	} // if
	else
	{
		node->str = (char *)malloc(len + 1);
		strcpy(node->str, str);
	} // else
} // create_ast


AST *
zzmk_ast(
AST *node,
int token,
char *str
)
{
	int len;
	
    node->token = token;
	len = strlen(str);
	if (str[0] == '\"')
	{
		node->str = (char *)malloc(len - 1);
		strncpy(node->str, &str[1], len - 2);
		node->str[len - 2] = '\0';
	} // if
	else
	{
		node->str = (char *)malloc(len + 1);
		strcpy(node->str, str);
	} // else
	
    return node;
} // zzmk_ast


AST * appendAst(AST * left, AST * right)
{
	if (left == NULL)
	{
		return right;
	} // if
	left->right = right;
	return left;
} // appendAst


#ifdef OMIT_APPENDAST
// Append right to left.
// If left is NULL, return right.
AST * appendAst(AST * left, AST * right)
{
	if (left == NULL)
	{
		return right;
	} // if
	else
	{
		left->right = right;
		return left;
	} // else
} // appendAst
#endif // OMIT_APPENDAST

#define ErrHdr "%s, line %d:"

void warn(char * msg)
{
	fprintf(stderr, ErrHdr, InFileName, zzline);
	fprintf(stderr, " warning: %s\n", msg);
} // warn

void showLevel(int level)
{
	int idx;
	for (idx = 0; idx < level; idx++)
	{
		printf("    ");
	} // for
} // showLevel


void showTree(AST *tree, int level)
{
	if (tree == NULL)
	{
		return;
	} // if
	
    while (tree != NULL)
	{
		showLevel(level);
		printf("(");
		if (tree->str != NULL)
		{
			printf("%d/%s/\"%s\"", tree->token,
			TokenNames[tree->token - 1], tree->str);
		} // if
		else
		{
			printf("%d/%s", tree->token, "--");
		} // else
		printf(")\n");
		showTree(tree->down, level + 1);
		tree = tree->right;
	} // while
} // showTree


void deleteTree(AST *tree)
{
	AST * tree1;
	
    if (tree == NULL)
	{
		return;
	} // if
	
    while (tree != NULL)
	{
		if (tree->str != NULL)
		{
			free(tree->str);
		} // if
		deleteTree(tree->down);
		tree1 = tree->right;
		free(tree);
		tree = tree1;
	} // while
} // deleteTree

// --------------------------------------------------------

static AST * findNextSiblingByType(AST * pNode, int type)
{
	AST * pN = pNode->right;
	
    while (pN != NULL)
	{
		if (pN->token == type)
		{
			return pN;
		} // if
		pN = pN->right;
	} // while
	return NULL;
} // findNextSiblingByType

// --------------------------------------------------------

AST * Parse(char * infilename, int show)
{
	AST * root = NULL;
	
    InFileName = (char *)malloc(strlen(infilename) + 1);
	strcpy(InFileName, infilename);
	
    if ((InFile = fopen(InFileName, "r")) == NULL)
	{
		printf("Can't open input file: %s\n", InFileName);
		exit(-1);
	} // if
	
    ANTLR(file_top_gram(&root), InFile);
	
    if (show)
	{
		showTree(root, 0);
	} // if
	
    fclose(InFile);
	
    return root;
} // Parse

  

void
#ifdef __STDC__
file_top_gram(AST**_root)
#else
file_top_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; bibliography_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(1); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_file_top_gram, "bibliography_file"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x1);
	}
} // file_top_gram

void
#ifdef __STDC__
bibliography_gram(AST**_root)
#else
bibliography_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(26); zzastDPush; zzCONSUME;
	_ast = NULL; bibliography_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; bibliography_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_bibliography_gram, "bibliography_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x2);
	}
} // bibliography_gram

void
#ifdef __STDC__
bibliography_item_gram(AST**_root)
#else
bibliography_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==47) ) {
			_ast = NULL; bibltitle_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==60) ) {
				_ast = NULL; documents_list_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && 
(LA(2)==59) ) {
					_ast = NULL; authors_list_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {zzFAIL(2,zzerr1,zzerr2,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x4);
	}
} // bibliography_item_gram

void
#ifdef __STDC__
bibliography_id_gram(AST**_root)
#else
bibliography_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_bibliography_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x8);
	}
} // bibliography_id_gram

void
#ifdef __STDC__
document_gram(AST**_root)
#else
document_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(29); zzastDPush; zzCONSUME;
	_ast = NULL; document_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; document_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_document_gram, "document_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x10);
	}
} // document_gram

void
#ifdef __STDC__
document_item_gram(AST**_root)
#else
document_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==48) ) {
			_ast = NULL; selecteditem_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==46) ) {
				_ast = NULL; doctitle_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && (LA(2)==45) ) {
					_ast = NULL; authorid_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {
					if ( (LA(1)==25) && 
(LA(2)==35) ) {
						_ast = NULL; pubs_gram(&_ast);
						ast1 = zzastArg(1);   
					}
					else {
						if ( (LA(1)==25) && (LA(2)==58) ) {
							_ast = NULL; keywords_list_gram(&_ast);
							ast1 = zzastArg(1);   
						}
						else {
							if ( (LA(1)==25) && (LA(2)==57) ) {
								_ast = NULL; xrefs_list_gram(&_ast);
								ast1 = zzastArg(1);   
							}
							else {
								if ( (LA(1)==25) && (LA(2)==56) ) {
									_ast = NULL; docnotes_list_gram(&_ast);
									ast1 = zzastArg(1);   
								}
								else {
									if ( (LA(1)==25) && (LA(2)==44) ) {
										_ast = NULL; docnotestitle_gram(&_ast);
										ast1 = zzastArg(1);   
									}
									else {zzFAIL(2,zzerr3,zzerr4,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
								}
							}
						}
					}
				}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x20);
	}
} // document_item_gram

void
#ifdef __STDC__
document_id_gram(AST**_root)
#else
document_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_document_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd1, 0x40);
	}
} // document_id_gram

void
#ifdef __STDC__
author_super_gram(AST**_root)
#else
author_super_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && 
(LA(2)==30) ) {
			_ast = NULL; author_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==34) ) {
				_ast = NULL; nonfictionauthor_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && (setwd1[LA(2)]&0x80) ) {
					_ast = NULL; fictionauthor_super_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {zzFAIL(2,zzerr5,zzerr6,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x1);
	}
} // author_super_gram

void
#ifdef __STDC__
author_gram(AST**_root)
#else
author_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(30); zzastDPush; zzCONSUME;
	_ast = NULL; author_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; author_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_author_gram, "author_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x2);
	}
} // author_gram

void
#ifdef __STDC__
author_item_gram(AST**_root)
#else
author_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==40) ) {
			_ast = NULL; name_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && 
(LA(2)==53) ) {
				_ast = NULL; publishedworks_list_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && (LA(2)==52) ) {
					_ast = NULL; worksinprogress_list_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {
					if ( (LA(1)==25) && (LA(2)==51) ) {
						_ast = NULL; authnotes_list_gram(&_ast);
						ast1 = zzastArg(1);   
					}
					else {
						if ( (LA(1)==25) && (LA(2)==39) ) {
							_ast = NULL; authnotestitle_gram(&_ast);
							ast1 = zzastArg(1);   
						}
						else {zzFAIL(2,zzerr7,zzerr8,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
					}
				}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x4);
	}
} // author_item_gram

void
#ifdef __STDC__
author_id_gram(AST**_root)
#else
author_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_author_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x8);
	}
} // author_id_gram

void
#ifdef __STDC__
fictionauthor_super_gram(AST**_root)
#else
fictionauthor_super_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==31) ) {
			_ast = NULL; fictionauthor_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && 
(LA(2)==32) ) {
				_ast = NULL; humorfictionauthor_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && (LA(2)==33) ) {
					_ast = NULL; romanticfictionauthor_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {zzFAIL(2,zzerr9,zzerr10,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x10);
	}
} // fictionauthor_super_gram

void
#ifdef __STDC__
fictionauthor_gram(AST**_root)
#else
fictionauthor_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(31); zzastDPush; zzCONSUME;
	_ast = NULL; fictionauthor_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; fictionauthor_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_fictionauthor_gram, "fictionauthor_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x20);
	}
} // fictionauthor_gram

void
#ifdef __STDC__
fictionauthor_item_gram(AST**_root)
#else
fictionauthor_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==41) ) {
			_ast = NULL; topicarea_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==40) ) {
				_ast = NULL; name_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && 
(LA(2)==53) ) {
					_ast = NULL; publishedworks_list_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {
					if ( (LA(1)==25) && (LA(2)==52) ) {
						_ast = NULL; worksinprogress_list_gram(&_ast);
						ast1 = zzastArg(1);   
					}
					else {
						if ( (LA(1)==25) && (LA(2)==51) ) {
							_ast = NULL; authnotes_list_gram(&_ast);
							ast1 = zzastArg(1);   
						}
						else {
							if ( (LA(1)==25) && (LA(2)==39) ) {
								_ast = NULL; authnotestitle_gram(&_ast);
								ast1 = zzastArg(1);   
							}
							else {zzFAIL(2,zzerr11,zzerr12,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
						}
					}
				}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x40);
	}
} // fictionauthor_item_gram

void
#ifdef __STDC__
fictionauthor_id_gram(AST**_root)
#else
fictionauthor_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_fictionauthor_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd2, 0x80);
	}
} // fictionauthor_id_gram

void
#ifdef __STDC__
humorfictionauthor_gram(AST**_root)
#else
humorfictionauthor_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(32); zzastDPush; zzCONSUME;
	_ast = NULL; humorfictionauthor_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; humorfictionauthor_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_humorfictionauthor_gram, "humorfictionauthor_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x1);
	}
} // humorfictionauthor_gram

void
#ifdef __STDC__
humorfictionauthor_item_gram(AST**_root)
#else
humorfictionauthor_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && 
(LA(2)==43) ) {
			_ast = NULL; style_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==41) ) {
				_ast = NULL; topicarea_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && (LA(2)==40) ) {
					_ast = NULL; name_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {
					if ( (LA(1)==25) && (LA(2)==53) ) {
						_ast = NULL; publishedworks_list_gram(&_ast);
						ast1 = zzastArg(1);   
					}
					else {
						if ( (LA(1)==25) && (LA(2)==52) ) {
							_ast = NULL; worksinprogress_list_gram(&_ast);
							ast1 = zzastArg(1);   
						}
						else {
							if ( (LA(1)==25) && 
(LA(2)==51) ) {
								_ast = NULL; authnotes_list_gram(&_ast);
								ast1 = zzastArg(1);   
							}
							else {
								if ( (LA(1)==25) && (LA(2)==39) ) {
									_ast = NULL; authnotestitle_gram(&_ast);
									ast1 = zzastArg(1);   
								}
								else {zzFAIL(2,zzerr13,zzerr14,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
							}
						}
					}
				}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x2);
	}
} // humorfictionauthor_item_gram

void
#ifdef __STDC__
humorfictionauthor_id_gram(AST**_root)
#else
humorfictionauthor_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_humorfictionauthor_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x4);
	}
} // humorfictionauthor_id_gram

void
#ifdef __STDC__
romanticfictionauthor_gram(AST**_root)
#else
romanticfictionauthor_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(33); zzastDPush; zzCONSUME;
	_ast = NULL; romanticfictionauthor_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; romanticfictionauthor_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_romanticfictionauthor_gram, "romanticfictionauthor_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x8);
	}
} // romanticfictionauthor_gram

void
#ifdef __STDC__
romanticfictionauthor_item_gram(AST**_root)
#else
romanticfictionauthor_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==42) ) {
			_ast = NULL; period_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==50) ) {
				_ast = NULL; emotionaltemperature_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && 
(LA(2)==41) ) {
					_ast = NULL; topicarea_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {
					if ( (LA(1)==25) && (LA(2)==40) ) {
						_ast = NULL; name_gram(&_ast);
						ast1 = zzastArg(1);   
					}
					else {
						if ( (LA(1)==25) && (LA(2)==53) ) {
							_ast = NULL; publishedworks_list_gram(&_ast);
							ast1 = zzastArg(1);   
						}
						else {
							if ( (LA(1)==25) && (LA(2)==52) ) {
								_ast = NULL; worksinprogress_list_gram(&_ast);
								ast1 = zzastArg(1);   
							}
							else {
								if ( (LA(1)==25) && (LA(2)==51) ) {
									_ast = NULL; authnotes_list_gram(&_ast);
									ast1 = zzastArg(1);   
								}
								else {
									if ( (LA(1)==25) && 
(LA(2)==39) ) {
										_ast = NULL; authnotestitle_gram(&_ast);
										ast1 = zzastArg(1);   
									}
									else {zzFAIL(2,zzerr15,zzerr16,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
								}
							}
						}
					}
				}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x10);
	}
} // romanticfictionauthor_item_gram

void
#ifdef __STDC__
romanticfictionauthor_id_gram(AST**_root)
#else
romanticfictionauthor_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_romanticfictionauthor_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x20);
	}
} // romanticfictionauthor_id_gram

void
#ifdef __STDC__
nonfictionauthor_gram(AST**_root)
#else
nonfictionauthor_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(34); zzastDPush; zzCONSUME;
	_ast = NULL; nonfictionauthor_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; nonfictionauthor_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_nonfictionauthor_gram, "nonfictionauthor_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x40);
	}
} // nonfictionauthor_gram

void
#ifdef __STDC__
nonfictionauthor_item_gram(AST**_root)
#else
nonfictionauthor_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==49) ) {
			_ast = NULL; doccount_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==55) ) {
				_ast = NULL; specialfields_list_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && (LA(2)==54) ) {
					_ast = NULL; biases_list_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {
					if ( (LA(1)==25) && 
(LA(2)==40) ) {
						_ast = NULL; name_gram(&_ast);
						ast1 = zzastArg(1);   
					}
					else {
						if ( (LA(1)==25) && (LA(2)==53) ) {
							_ast = NULL; publishedworks_list_gram(&_ast);
							ast1 = zzastArg(1);   
						}
						else {
							if ( (LA(1)==25) && (LA(2)==52) ) {
								_ast = NULL; worksinprogress_list_gram(&_ast);
								ast1 = zzastArg(1);   
							}
							else {
								if ( (LA(1)==25) && (LA(2)==51) ) {
									_ast = NULL; authnotes_list_gram(&_ast);
									ast1 = zzastArg(1);   
								}
								else {
									if ( (LA(1)==25) && (LA(2)==39) ) {
										_ast = NULL; authnotestitle_gram(&_ast);
										ast1 = zzastArg(1);   
									}
									else {zzFAIL(2,zzerr17,zzerr18,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
								}
							}
						}
					}
				}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd3, 0x80);
	}
} // nonfictionauthor_item_gram

void
#ifdef __STDC__
nonfictionauthor_id_gram(AST**_root)
#else
nonfictionauthor_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_nonfictionauthor_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x1);
	}
} // nonfictionauthor_id_gram

void
#ifdef __STDC__
pubs_gram(AST**_root)
#else
pubs_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(35); zzastDPush; zzCONSUME;
	_ast = NULL; pubs_id_gram(&_ast);
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25)
 ) {
			_ast = NULL; pubs_item_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_pubs_gram, "pubs_gram"), zzastArg(3), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x2);
	}
} // pubs_gram

void
#ifdef __STDC__
pubs_item_gram(AST**_root)
#else
pubs_item_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==25) && (LA(2)==38) ) {
			_ast = NULL; publisher_gram(&_ast);
			ast1 = zzastArg(1);   
		}
		else {
			if ( (LA(1)==25) && (LA(2)==37) ) {
				_ast = NULL; location_gram(&_ast);
				ast1 = zzastArg(1);   
			}
			else {
				if ( (LA(1)==25) && (LA(2)==36) ) {
					_ast = NULL; date_gram(&_ast);
					ast1 = zzastArg(1);   
				}
				else {zzFAIL(2,zzerr19,zzerr20,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
			}
		}
		zzEXIT(zztasp2);
		}
	}
	(*_root) = ast1;   
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x4);
	}
} // pubs_item_gram

void
#ifdef __STDC__
pubs_id_gram(AST**_root)
#else
pubs_id_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(SYMBOL); zzastDPush;
	(*_root) = zzmk_ast(zzastnew(),Tok_pubs_id_gram, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x8);
	}
} // pubs_id_gram

void
#ifdef __STDC__
date_gram(AST**_root)
#else
date_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(36); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_date_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x10);
	}
} // date_gram

void
#ifdef __STDC__
location_gram(AST**_root)
#else
location_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(37); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_location_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x20);
	}
} // location_gram

void
#ifdef __STDC__
publisher_gram(AST**_root)
#else
publisher_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(38); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_publisher_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x40);
	}
} // publisher_gram

void
#ifdef __STDC__
authnotestitle_gram(AST**_root)
#else
authnotestitle_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(39); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_authnotestitle_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd4, 0x80);
	}
} // authnotestitle_gram

void
#ifdef __STDC__
name_gram(AST**_root)
#else
name_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(40); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_name_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x1);
	}
} // name_gram

void
#ifdef __STDC__
topicarea_gram(AST**_root)
#else
topicarea_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(41); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_topicarea_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x2);
	}
} // topicarea_gram

void
#ifdef __STDC__
period_gram(AST**_root)
#else
period_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(42); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_period_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x4);
	}
} // period_gram

void
#ifdef __STDC__
style_gram(AST**_root)
#else
style_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(43); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_style_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x8);
	}
} // style_gram

void
#ifdef __STDC__
docnotestitle_gram(AST**_root)
#else
docnotestitle_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(44); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_docnotestitle_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x10);
	}
} // docnotestitle_gram

void
#ifdef __STDC__
authorid_gram(AST**_root)
#else
authorid_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(45); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_authorid_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x20);
	}
} // authorid_gram

void
#ifdef __STDC__
doctitle_gram(AST**_root)
#else
doctitle_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(46); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_doctitle_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x40);
	}
} // doctitle_gram

void
#ifdef __STDC__
bibltitle_gram(AST**_root)
#else
bibltitle_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(47); zzastDPush; zzCONSUME;
	zzmatch(STRING); zzastDPush; zzCONSUME;
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_bibltitle_gram, zzaArg(zztasp1,3)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd5, 0x80);
	}
} // bibltitle_gram

void
#ifdef __STDC__
selecteditem_gram(AST**_root)
#else
selecteditem_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	char buf[64];   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(48); zzastDPush; zzCONSUME;
	_ast = NULL; boolean_gram(&_ast, buf );
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_selecteditem_gram, buf), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x1);
	}
} // selecteditem_gram

void
#ifdef __STDC__
doccount_gram(AST**_root)
#else
doccount_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	char buf[128];   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(49); zzastDPush; zzCONSUME;
	_ast = NULL; int_gram(&_ast, buf );
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_doccount_gram, buf), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x2);
	}
} // doccount_gram

void
#ifdef __STDC__
emotionaltemperature_gram(AST**_root)
#else
emotionaltemperature_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	char buf[128];   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(50); zzastDPush; zzCONSUME;
	_ast = NULL; float_gram(&_ast, buf );
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_emotionaltemperature_gram, buf), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x4);
	}
} // emotionaltemperature_gram

void
#ifdef __STDC__
authnotes_list_gram(AST**_root)
#else
authnotes_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(51); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==STRING) ) {
			_ast = NULL; string_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_authnotes_list_gram, "authnotes_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x8);
	}
} // authnotes_list_gram

void
#ifdef __STDC__
worksinprogress_list_gram(AST**_root)
#else
worksinprogress_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(52); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25)
 ) {
			_ast = NULL; document_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_worksinprogress_list_gram, "worksinprogress_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x10);
	}
} // worksinprogress_list_gram

void
#ifdef __STDC__
publishedworks_list_gram(AST**_root)
#else
publishedworks_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(53); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; document_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_publishedworks_list_gram, "publishedworks_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x20);
	}
} // publishedworks_list_gram

void
#ifdef __STDC__
biases_list_gram(AST**_root)
#else
biases_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(54); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==STRING) ) {
			_ast = NULL; string_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_biases_list_gram, "biases_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x40);
	}
} // biases_list_gram

void
#ifdef __STDC__
specialfields_list_gram(AST**_root)
#else
specialfields_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(55); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==STRING) ) {
			_ast = NULL; string_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_specialfields_list_gram, "specialfields_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd6, 0x80);
	}
} // specialfields_list_gram

void
#ifdef __STDC__
docnotes_list_gram(AST**_root)
#else
docnotes_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(56); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==STRING) ) {
			_ast = NULL; string_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_docnotes_list_gram, "docnotes_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x1);
	}
} // docnotes_list_gram

void
#ifdef __STDC__
xrefs_list_gram(AST**_root)
#else
xrefs_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(57); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==STRING)
 ) {
			_ast = NULL; string_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_xrefs_list_gram, "xrefs_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x2);
	}
} // xrefs_list_gram

void
#ifdef __STDC__
keywords_list_gram(AST**_root)
#else
keywords_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(58); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==STRING) ) {
			_ast = NULL; string_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_keywords_list_gram, "keywords_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x4);
	}
} // keywords_list_gram

void
#ifdef __STDC__
authors_list_gram(AST**_root)
#else
authors_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(59); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; author_super_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_authors_list_gram, "authors_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x8);
	}
} // authors_list_gram

void
#ifdef __STDC__
documents_list_gram(AST**_root)
#else
documents_list_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	AST *ast1 = NULL;   
	zzmatch(25); zzastDPush; zzCONSUME;
	zzmatch(60); zzastDPush; zzCONSUME;
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		while ( (LA(1)==25) ) {
			_ast = NULL; document_gram(&_ast);
			ast1 = appendAst(zzastArg(1), ast1);   
			zzLOOP(zztasp2);
		}
		zzEXIT(zztasp2);
		}
	}
	zzmatch(27); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_documents_list_gram, "documents_list_gram"), ast1, NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x10);
	}
} // documents_list_gram

void
#ifdef __STDC__
boolean_gram(AST**_root, char * buf )
#else
boolean_gram(_root,buf)
AST **_root;
 char * buf ;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	{
		zzBLOCK(zztasp2);
		zzMake0;
		{
		if ( (LA(1)==61) ) {
			zzmatch(61); zzsubchild(_root, &_sibling, &_tail);
			strcpy(buf, "\"true\"");   
 zzCONSUME;
		}
		else {
			if ( (LA(1)==62)
 ) {
				zzmatch(62); zzsubchild(_root, &_sibling, &_tail);
				strcpy(buf, "\"false\"");   
 zzCONSUME;
			}
			else {zzFAIL(1,zzerr21,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
		}
		zzEXIT(zztasp2);
		}
	}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x20);
	}
} // boolean_gram

void
#ifdef __STDC__
string_gram(AST**_root)
#else
string_gram(_root)
AST **_root;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(STRING); zzastDPush;
	(*_root) = zztmake(zzmk_ast(zzastnew(),Tok_string_gram, zzaArg(zztasp1,1)), NULL);   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x40);
	}
} // string_gram

void
#ifdef __STDC__
int_gram(AST**_root, char * buf )
#else
int_gram(_root,buf)
AST **_root;
 char * buf ;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	zzmatch(INTEGER); zzsubchild(_root, &_sibling, &_tail);
	strcpy(buf, zzaArg(zztasp1,1));   
 zzCONSUME;
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd7, 0x80);
	}
} // int_gram

void
#ifdef __STDC__
float_gram(AST**_root, char * buf )
#else
float_gram(_root,buf)
AST **_root;
 char * buf ;
#endif
{
	zzRULE;
	zzBLOCK(zztasp1);
	zzMake0;
	{
	if ( (LA(1)==FLOAT) ) {
		zzmatch(FLOAT); zzsubchild(_root, &_sibling, &_tail);
		strcpy(buf, zzaArg(zztasp1,1));   
 zzCONSUME;
	}
	else {
		if ( (LA(1)==INTEGER) ) {
			zzmatch(INTEGER); zzsubchild(_root, &_sibling, &_tail);
			strcpy(buf, zzaArg(zztasp1,1));   
 zzCONSUME;
		}
		else {zzFAIL(1,zzerr22,&zzMissSet,&zzMissText,&zzBadTok,&zzBadText,&zzErrk); goto fail;}
	}
	zzEXIT(zztasp1);
	return;
fail:
	zzEXIT(zztasp1);
	zzsyn(zzMissText, zzBadTok, (ANTLRChar *)"", zzMissSet, zzMissTok, zzErrk, zzBadText);
	zzresynch(setwd8, 0x1);
	}
} // float_gram
