
# Copyright (c) 1994 G. David Kuhlman.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in
# all copies of this software.
#
# IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
# OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
# HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
# ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
# PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

CC = icc
CFLAGS = /c /Q /Gm /Ti /I$(INCLUDEPATH)
LFLAGS = /de /pmtype:vio /nologo /noi /align:16 /exepack /base:65536
LIB = lib.exe
LINK = link386.exe
INCLUDEPATH = ..\kr;..\h;..\db;..\sup;d:\btree


#=============================================================
#       Implicit Rules
#=============================================================
.c.obj:
  $(CC) -c $(CFLAGS) $<

.cpp.obj:
  $(CC) -c $(CFLAGS) $<


#=============================================================
#       List Macros
#=============================================================


EXE_DEPENDENCIES =  \
 krc.obj \
 getopt.obj

LIBS = ..\libi\db.lib ..\libi\kr.lib ..\libi\sup.lib

#=============================================================
#       Explicit Rules
#=============================================================
krc.exe: krci.lnk $(EXE_DEPENDENCIES) $(LIBS)
    $(LINK) @krci.lnk

#=============================================================
#       Linker File
#=============================================================
krci.lnk: krci.mak
  @echo Creating krci.lnk <<krci.lnk
$(LFLAGS) +
krc.obj +
getopt.obj
krc.exe
nul.map
\btree\ibm\btree +
kr db sup +
dde4muii.lib
nul.def
<<keep


#=============================================================
#       Individual File Dependencies
#=============================================================
krc.obj: krc.cfg krc.cpp ..\db\db.hpp

getopt.obj: getopt.c
    $(CC) -DUSG $(CFLAGS) getopt.c


