// krstrm.cpp    Member functions for KrOstream

/*
* Copyright (c) 1994 G. David Kuhlman.
* All rights reserved.
*
* Permission is hereby granted, without written agreement and without
* license or royalty fees, to use, copy, modify, and distribute this
* software and its documentation for any purpose, provided that the
* above copyright notice and the following two paragraphs appear in
* all copies of this software.
* 
* IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
* DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
* OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
* HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
* AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
* ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
* PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/

#include "krstrm.hpp"

// --------------------------------------------------------
// --------------------------------------------------------

KrOstream::KrOstream()
: ofstream()
{

} // KrOstream::KrOstream

// --------------------------------------------------------

KrOstream::KrOstream(
    const char *fname,
    int mode,
    int prot
)
: ofstream(fname, mode, prot)
{
} // KrOstream::KrOstream

// --------------------------------------------------------

KrOstream::KrOstream(const KrOstream& rhs)
: ofstream()
{
    if (this == &rhs)
    {
        return;
    } // if

} // KrOstream::KrOstream

// --------------------------------------------------------

KrOstream::~KrOstream()
{

} // KrOstream::~KrOstream

// --------------------------------------------------------

KrOstream & KrOstream::operator =(const KrOstream& rhs)
{
    if (this == &rhs)
    {
        return *this;
    } // if

    return *this;
} // KrOstream::operator =

// --------------------------------------------------------

KrOstream & KrOstream::operator <<=(int level)
{
    int idx;
    for (idx = 0; idx < level; idx++)
    {
        *this << "    ";
    } // for
    return *this;
} // KrOstream::operator

// --------------------------------------------------------

