# Copyright (c) 1994 G. David Kuhlman.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in
# all copies of this software.
#
# IN NO EVENT SHALL G. DAVID KUHLMAN BE LIABLE TO ANY PARTY FOR
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
# OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF G. DAVID KUHLMAN
# HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# G. DAVID KUHLMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
# ON AN "AS IS" BASIS, AND G. DAVID KUHLMAN HAS NO OBLIGATION TO
# PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.


#=============================================================
#		Translator Definitions
#=============================================================
CC = icc
CFLAGS = /c /Q /Gm /Ti /I$(INCLUDEPATH)
LFLAGS = /de /pmtype:vio /nologo /noi /align:16 /exepack /base:65536
LIB = lib.exe
LINK = link386
INCLUDEPATH = ..\h;..\db


#=============================================================
#		Implicit Rules
#=============================================================
.c.obj:
  $(CC) -c $(CFLAGS) $<

.cpp.obj:
  $(CC) -c $(CFLAGS) $<

#=============================================================
#		List Macros
#=============================================================


LIB_DEPENDENCIES =  \
 sup.obj \
 krstrg.obj \
 krstrm.obj

#=============================================================
#		Explicit Rules
#=============================================================
sup.lib: sup.cfg $(LIB_DEPENDENCIES)
    - del sup.lib
    $(LIB) sup +sup.obj +krstrg.obj +krstrm.obj;
    - del ..\libi\sup.lib
    move sup.lib ..\libi


#=============================================================
#		Individual File Dependencies
#=============================================================
sup.obj: sup.cfg sup.cpp 

krstrg.obj: sup.cfg krstrg.cpp ..\db\db.hpp

krstrm.obj: sup.cfg krstrm.cpp


